【Leetcode每日一题】二分查找 - 寻找峰值(难度⭐⭐)(20)

1. 题目解析

Leetcode链接:162. 寻找峰值

这个问题的理解其实相当简单,只需看一下示例,基本就能明白其含义了。

核心在于找到题目中所说的峰值并返回他们的下标即可。


2. 算法原理

分析峰顶及其两旁数据的特点

  1. 峰顶数据特点 :峰顶元素arr[i]满足条件arr[i] > arr[i - 1]且arr[i] > arr[i + 1],即它大于其前后两个元素。
  2. 峰顶左边数据特点 :对于峰顶左侧的元素arr[i],其满足arr[i] > arr[i - 1]且arr[i] < arr[i + 1],这意味着从左侧向峰顶看,数据呈现上升趋势。
  3. 峰顶右边数据特点 :对于峰顶右侧的元素arr[i],其满足arr[i] < arr[i - 1]且arr[i] > arr[i + 1],这表明从峰顶向右侧看,数据呈现下降趋势。

根据mid位置信息进行搜索

根据mid位置的数据特点,我们可以分为以下三种情况来缩小搜索范围:

  1. 如果mid位置呈现上升趋势 :这表示当前峰顶还未被找到,且它必定位于mid的右侧。因此,接下来的搜索范围应缩小至[mid + 1, right]区间。
  2. 如果mid位置呈现下降趋势 :这表示当前峰顶位于mid或其左侧。为了找到峰顶,接下来的搜索范围应缩小至[left, mid - 1]区间。
  3. 如果mid位置就是峰顶:在这种情况下,我们已经找到了目标峰顶,可以直接返回结果。

3. 代码编写

复制代码
class Solution {
public:
    int findPeakElement(vector<int>& nums) {
        int left = 1, right = nums.size() - 2, mid = 0;
        while(left < right)
        {
            mid = (left + right) / 2;
            if(nums[mid] > nums[mid + 1])
            {
                right = mid;
            }
            else
            {
                left = mid + 1;
            }
        }
        return right;
    }
};

The Last

嗯,就是这样啦,文章到这里就结束啦,真心感谢你花时间来读。

觉得有点收获的话,不妨给我点个赞吧!

如果发现文章有啥漏洞或错误的地方,欢迎私信我或者在评论里提醒一声~

相关推荐
碧海银沙音频科技研究院37 分钟前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法
通问AI1 小时前
在两台 Mac Studio 上跑 800B 模型:MLX + RDMA over Thunderbolt 实测与四道门选型法
算法
ZywOo6231 小时前
《算法竞赛进阶指南》0x03 前缀和与差分
算法
Scintilla_y1 小时前
DAY2 滑动窗口
算法·leetcode·散列表
lvwangshu1 小时前
笛卡尔树
算法·图论
026d232 小时前
状态信号只知“其然”不知“其所以然”:变工况机械故障诊断的物理盲区
算法
姜鱼问生2 小时前
备份和服务器在同一台机器上,等于没备份
算法·架构
姜鱼问生2 小时前
别再 chmod 777 了,用 ACL 给它开一扇窗
后端·算法·架构
特立独行的猫a2 小时前
仓颉语言UI开发实战:我用仓颉写了个桌面版力扣
算法·leetcode·ui·tauri·仓颉·cj-tarui
y1su2 小时前
Leetcode 动态规划 模板
java·数据结构·算法·leetcode·动态规划